unit FMXWin;
{
 Demo-Program for TLMDAboutDlg, TLMDDirDlg, TLMDSysInfo, TLMDTipDlg
 and TLDMAboutDlg.

 The code bases heavingly on the Filemanex-Example shipped with Delphi,
 but without using fmxutils.pas or something similar.

 Besides the code demonstrates some further techniques like saving the
 forms measurements by using the TIniFileExt-Object of LmDTools.Pas (or if you
 do not own the sourcecode: LMDTools.DCU - look at the helpfile for more
 informations.

  This example demonstrates how to use the following components of the LMD-Tools package:
  - TLMDSystemInfo
  - TLMDFile
  - TLMDTipDlg
  - TLMDDirDlg
  - TLMDAboutDlg

  With TLMDSystemInfo you get informations about free resources, WINDOWS and DOS-version
  and more. You just have to read out the properties. See SYSINFO.PAS for further details.

  TLMDFile allows you to get multiple file properties. This example shows how to get them
  and how to copy, move, rename and delete files by manipulating the TLMDFile properties.
  Please note that you don't need the unit FMXUtils.Pas.
  See line 283-310 in FMXWIN.PAS for getting file properties
  See line 259-289 in FMXWIN.PAS for copy, move and rename files

  TLMDTipDlg works similar to the Tip dialog used in MS Winword for example. To create
  your own tips, just change the tips property and put the execute command in your code.
  To show the Tip Dialog at start, set the "Showatstart" property to TRUE.

  TLMDAboutDlg only requires the execute command to be shown.


  This program is freeware. Use it and enjoy!
  If you made any improvements it would be nice to send them to us.

   1995 by LMD Innovative

 ------------------------------------------------------------------
 History:
 0.01.00 (06.08.95): First Version

 Author: OW}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, FileCtrl, Grids, Outline, DirOutln, Tabs, Menus, Dialogs,
  FAttrDlg, FChngDlg, {FMXUtils,} ExtCtrls, Buttons, Lmdfile, lmdtips,
  Lmdsysin,sysinfo, progrdlg, lmdtools, Lmdabout;

type
  TFMForm = class(TForm)
    DriveTabSet: TTabSet;
    DirectoryOutline: TDirectoryOutline;
    FileList: TFileListBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Move1: TMenuItem;
    Copy1: TMenuItem;
    Delete1: TMenuItem;
    Rename1: TMenuItem;
    Properties1: TMenuItem;
    Exit1: TMenuItem;
    Panel1: TPanel;
    Floppy: TImage;
    Fixed: TImage;
    Network: TImage;
    FreeSpace: TPanel;
    SelSize: TPanel;
    LMDTipDlg1: TLMDTipDlg;
    LMDFile1: TLMDFile;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    N2: TMenuItem;
    N3: TMenuItem;
    System1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N4: TMenuItem;
    Tips1: TMenuItem;
    Info1: TMenuItem;
    CDROM: TImage;
    SpeedButton6: TSpeedButton;
    N1: TMenuItem;
    LMDAboutDlg1: TLMDAboutDlg;
    SpeedButton8: TSpeedButton;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DriveTabSetClick(Sender: TObject);
    procedure DirectoryOutlineChange(Sender: TObject);
    procedure FileListChange(Sender: TObject);
    procedure DriveTabSetMeasureTab(Sender: TObject; Index: Integer;
      var TabWidth: Integer);
    procedure DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas;
      R: TRect; Index: Integer; Selected: Boolean);
    procedure File1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure FileChange(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FileListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DirectoryOutlineDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure DirectoryOutlineDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure DriveTabSetChange(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);

    {Add-On's}
    procedure SetPanelData(Drive :char);
    procedure Info1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LMDFile1Progress(Sender: TObject; ActData: TActualData);
    procedure LMDFile1Start(Sender: TObject; ActData: TActualData);
    procedure LMDFile1End(Sender: TObject; ActData: TActualData);
    procedure About1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LoadIni;
    procedure SaveIni;
    procedure SpeedButton8Click(Sender: TObject);
  private
    { Private declarations }
    procedure ConfirmChange(const ACaption, FromFile, ToFile: string);
  public
    { Public declarations }
    procedure Updatebuttons;
  end;

const
  StrDrivenotready='Drive %s is not ready! Please insert a disk into the appropiate drive and try again.';
  StrDeleteFile='Delete %s ?';
  Strfilenotfound='File not found';
var
  FMForm: TFMForm;
  IniFile :TIniFileExt;
  fshow:boolean;

{Utils}
function DiskInDrive(Drive :char): boolean;


implementation
{$R *.DFM}

procedure TFMForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFMForm.FormCreate(Sender: TObject);
var
  Drive, AddedIndex: Integer;
  DriveLetter: Char;
  CurDir :string;
begin
  {load INI-file}
  loadIni;

  for Drive := 0 to 25 do
  begin
    DriveLetter := Chr(Drive + ord('a'));
    case GetDriveType(Drive) of
      DRIVE_REMOVABLE:
          AddedIndex := DriveTabSet.Tabs.AddObject(Upcase(DriveLetter), Floppy.Picture.Graphic);
      DRIVE_FIXED:
          AddedIndex := DriveTabSet.Tabs.AddObject(Upcase(DriveLetter), Fixed.Picture.Graphic);
      DRIVE_REMOTE:
        if ISCdrom(Drive) then  {Using the function from LMDTools}
          AddedIndex := DriveTabSet.Tabs.AddObject(Upcase(DriveLetter), CDROM.Picture.Graphic)
        else
          AddedIndex := DriveTabSet.Tabs.AddObject(Upcase(DriveLetter), Network.Picture.Graphic);
    end;
    if UpCase(DriveLetter) = UpCase(FileList.Drive) then
      DriveTabSet.TAbIndex := AddedIndex;
  end;
  {Update Statusline}
  GetDir(0, curdir);
  SetPanelData(curdir[1]);
end;

procedure TFMForm.DriveTabSetClick(Sender: TObject);
begin
  with DriveTabSet do
    if DiskInDrive(Tabs[TabIndex][1]) then {Check it first...}
      DirectoryOutline.Drive := Tabs[TabIndex][1] {O.k. -> change drive}
    else
      ShowMessage(Format(strdrivenotready,[Tabs[TabIndex][1]]));
end;

procedure TFMForm.DirectoryOutlineChange(Sender: TObject);
begin
  {Update Statusline}
  Screen.Cursor := crHourglass;
  try
    FileList.Directory := DirectoryOutline.Directory;
    SelSize.Caption := DirectoryOutline.Directory;
    Updatebuttons;    {Check speedbuttons}
    Filelist.Update;
    {inform user, that the directory is empty}
    if filelist.items.count=0 then
      filelist.items.add(Strfilenotfound);
  finally
    Screen.Cursor := crdefault;
  end;
end;


procedure TFMForm.FileListChange(Sender: TObject);
var
  TheFileName: string;
  size :longint;
begin
  if Filelist.ItemIndex >= 0 then with lmdfile1 do begin
    FileName := Filelist.FileName; {store the selected filename for later use...}
    if filesize>-1 then
      SelSize.Caption := Format('%s, %d bytes', [ExtractFilename(FileName), Filesize])
    else
      SelSize.Caption := DirectoryOutline.Directory;

  end;
  Updatebuttons;
end;

procedure TFMForm.DriveTabSetMeasureTab(Sender: TObject; Index: Integer;
  var TabWidth: Integer);
var
  BitmapWidth: Integer;
begin
  BitmapWidth := TBitmap(DriveTabSet.Tabs.Objects[Index]).Width;
  Inc(TabWidth, 2 + BitmapWidth);
end;

procedure TFMForm.DriveTabSetDrawTab(Sender: TObject; TabCanvas: TCanvas;
  R: TRect; Index: Integer; Selected: Boolean);
var
  Bitmap: TBitmap;
begin
  Bitmap := TBitmap(DriveTabSet.Tabs.Objects[Index]);
  with TabCanvas do
  begin
    Draw(R.Left, R.Top + 4, Bitmap);
    TextOut(R.Left + 2 + Bitmap.Width, R.Top + 2, DriveTabSet.Tabs[Index]);
  end;
end;

procedure TFMForm.File1Click(Sender: TObject);
var
  FileSelected: Boolean;
begin
  {check menu items...}
  FileSelected := FileList.ItemIndex >= 0;
  Open1.Enabled := FileSelected;
  Delete1.Enabled := FileSelected;
  Copy1.Enabled := FileSelected;
  Move1.Enabled := FileSelected;
  Rename1.Enabled := FileSelected;
  Properties1.Enabled := FileSelected;
end;

procedure TFMForm.Delete1Click(Sender: TObject);
begin
  with FileList do
    if MessageDlg(Format(StrDeleteFile,[Filename]), mtConfirmation,
      [mbYes, mbNo], 0) = idYes then begin
        LMDFile1.aDeleteFile:=''; {Empty string to delete current file}
        Update;
  end;
end;

procedure TFMForm.Properties1Click(Sender: TObject);
var
  Attributes, NewAttributes: Word;
begin
  with FileAttrForm do
  begin
    {Fill the form with the file properties...}
    lblFileName.Caption := LMDFile1.FileNameAlone;
    lblFilePath.Caption := LMDFile1.FilePath;
    lblFileDate.Caption := LMDFile1.FileDate;
    lblFileTime.Caption := LMDFile1.FileTime;
    ReadOnly.Checked := ftReadOnly in LMDFile1.FileAttributes;
    Archive.Checked := ftArchive in LMDFile1.FileAttributes;
    System.Checked := ftSystem in LMDFile1.FileAttributes;
    Hidden.Checked := ftHidden in LMDFile1.FileAttributes;
    if ShowModal <> idCancel then with LMDFile1 do begin
      NewAttributes := Attributes;
      if ReadOnly.Checked then FileAttributes := FileAttributes + [ftReadOnly]
        else FileAttributes := FileAttributes - [ftReadOnly];
      if Hidden.Checked then FileAttributes := FileAttributes + [ftHidden]
        else FileAttributes := FileAttributes - [ftHidden];
      if System.Checked then FileAttributes := FileAttributes + [ftSystem]
        else FileAttributes := FileAttributes - [ftSystem];
      if Archive.Checked then FileAttributes := FileAttributes + [ftArchive]
        else FileAttributes := FileAttributes - [ftArchive];
    end;
  end;
end;

procedure TFMForm.ConfirmChange(const ACaption, FromFile, ToFile: string);
var i:integer;
begin
  if MessageDlg(Format('%s %s to %s', [ACaption, FromFile, ToFile]),
    mtConfirmation, [mbYes, mbNo], 0) = idYes then
  with LMDFile1 do begin
    Filename := FromFile;
    if ACaption = 'Move' then
      aMoveFile := ToFile
     else if ACaption = 'Copy' then
       aCopyFile := ToFile
     else if ACaption = 'Rename' then
       aRenameFile := ToFile;

    FileList.Update;
  end; {with}
end;

procedure TFMForm.FileChange(Sender: TObject);
begin
  with ChangeForm do
  begin
    if Sender = Move1 then Caption := 'Move'
    else if Sender = Copy1 then Caption := 'Copy'
    else if Sender = Rename1 then Caption := 'Rename'
    else Exit;
    CurrentDir.Caption := FileList.Directory;
    FromFileName.Text := FileList.FileName;
    ToFileName.Text := '';
    if (ShowModal <> idCancel) and (ToFileName.Text <> '') then
      ConfirmChange(Caption, FromFileName.Text, ToFileName.Text);
  end;
end;

procedure TFMForm.Open1Click(Sender: TObject);
begin
  {Just change the property to execute it...}
  with LMDFile1 do
    aExecuteFile := Filelist.FileName;
end;

procedure TFMForm.FileListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    with Sender as TFileListBox do
    begin
      if ItemAtPos(Point(X, Y), True) >= 0 then
        BeginDrag(False);
    end;
end;

procedure TFMForm.DirectoryOutlineDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source is TFileListBox then
    Accept := True;
end;

procedure TFMForm.DirectoryOutlineDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source is TFileListBox then
    with DirectoryOutline do
    begin
      ConfirmChange('Move', FileList.FileName, Items[GetItem(X, Y)].FullPath);
    end;
end;

procedure TFMForm.FileListEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  if Target <> nil then FileList.Update;
end;

{This function checks, if the specified drive is ready (see also Borland Techn. Information
 No 2857}
function DiskInDrive(Drive :char): boolean;
var Errormode: word;
begin

  if Drive in ['a'..'z'] then Dec(Drive, $20);
  if not (Drive in ['A'..'Z'] ) then
    raise EConvertError.CreateFmt('%c is not a valid drive!', [Drive]);

  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
  try
    {drive 1=a, 2 = b, 3=c...}
    if DiskSize(Ord(Drive)-$40)=-1 then
      Result := false
    else
      result := true;
  finally
    SetErrorMode(Errormode);
  end;
end;
procedure TFMForm.DriveTabSetChange(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  with DriveTabSet do begin
    {If specified drive is ready, allow change}
    AllowChange := DiskInDrive(Tabs[NewTab][1]);
    if AllowChange then begin
      DirectoryOutline.Drive := Tabs[NewTab][1] {O.k. -> change drive};
      SetPanelData(Tabs[NewTab][1]);
    end else if {inform user that drive is not ready...}
      MessageDlg(Format(StrDrivenotready,[Tabs[NewTab][1]]),mtInformation, [mbCancel, mbRetry],0)=mrRetry then
        DriveTabSetChange(Sender, Newtab, allowchange); {Do loop again}
  end;
end;

{Update Statusline}
procedure TFMForm.SetPanelData(Drive :char);
var
  prz :real;
  freesize, fullsize:longint;
begin
  if Drive in ['a'..'z'] then Dec(Drive, $20);
  if not (Drive in ['A'..'Z'] ) then begin
    Freespace.Caption := '';
    exit; {nothing more to do here...}
  end else begin {fill panel with data}
    freesize := Diskfree(Ord(Drive) - $40) div 1024;
    fullsize := Disksize(Ord(Drive) - $40) div 1024;
    if fullsize<>0 then
      prz := freesize/fullsize*100;
    Freespace.Caption := Format('%s : %d bytes free (%f3 %%)',[drive, freesize, prz]);
  end;
end;

procedure TFMForm.Info1Click(Sender: TObject);
begin
  sysinfodlg.show;
end;

procedure TFMForm.FormActivate(Sender: TObject);
begin

  if not fshow then
    begin
      LMDTipDlg1.Execute;
      fshow:=true;
      lmdtipdlg1.mode:=monormal;
      {at now no checking of state is necessary}
    end;
end;

procedure TFMForm.LMDFile1Progress(Sender: TObject; ActData: TActualData);
begin
  progressdlg.gauge1.progress := LMDFile1.processed;
end;

procedure TFMForm.LMDFile1Start(Sender: TObject; ActData: TActualData);
begin
  with progressdlg do begin
    {Pick out the current action...}
    {fcNone, fcChange, fcCreate, fcCopy, fcMove, fcDelete, fcRename, fcExecute)}
    case actdata.action of
      fcCopy   : Caption := 'Copy file...';
      fcMove   : Caption := 'Move file...';
      else exit; {In other cases the dialog is not necessary...}
    end;
    {Show source and destination with the Actdata-record}
    label1.Caption := ActData.source;
    label2.caption := ActData.destination;
    Show; {... and show it}
  end;
end;

procedure TFMForm.LMDFile1End(Sender: TObject; ActData: TActualData);
begin
  {Hide the dialog if shown before...}
  if progressdlg.visible then
    progressdlg.Hide; {action ending here...}
end;

procedure TFMForm.About1Click(Sender: TObject);
begin
  {Who has made this stuff...}
  LMDAboutDlg1.execute
end;

procedure TFMForm.SpeedButton2Click(Sender: TObject);

begin
  with ChangeForm do begin
    case TComponent(Sender).Tag of
      0: Caption := 'Copy';
      1: Caption := 'Move';
      2: Caption := 'Rename';
    end;

    CurrentDir.Caption := FileList.Directory;
    FromFileName.Text := FileList.FileName;
    ToFileName.Text := '';
    if (ShowModal <> idCancel) and (ToFileName.Text <> '') then
      ConfirmChange(Caption, FromFileName.Text, ToFileName.Text);
  end;
end;

procedure TFMForm.SpeedButton8Click(Sender: TObject);
begin
  lmdtipdlg1.execute;
end;

procedure TFMForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {save window measurements and its state into the lmd.ini}
  saveini;
end;

procedure TFMForm.Updatebuttons;
var
  Enablethem :boolean;
begin
  Enablethem := Filelist.Itemindex<>-1;
  Speedbutton1.Enabled := Enablethem;
  Speedbutton2.Enabled := Enablethem;
  Speedbutton3.Enabled := Enablethem;
  Speedbutton4.Enabled := Enablethem;
  Speedbutton5.Enabled := Enablethem;
  Speedbutton6.Enabled := Enablethem;
end;

{The procedures Loadini/Saveini shows how to save the windows measurements by using
 TIniFileExt (see also LMDTOOLS.PAS)}

procedure TFMForm.LoadIni;
var inifile :TIniFileExt; dummy: integer;
begin
  inifile := TIniFileExt.Create('lmdapp.ini');
  try
    with inifile do
      begin
        RestoreWinStatus(FMForm, 'MainWindow');
        lmdtipdlg1.ShowAtStart:=readbool('Tips','ShowAtStart',True);
      end;
  finally
    inifile.free;
  end;
end;

procedure TFMForm.SaveIni;
var inifile :TIniFileExt; dummy: integer;
begin
  inifile := TIniFileExt.Create('lmdapp.ini');
  try
    with inifile do
      begin
        SaveWinStatus(FMForm, 'MainWindow');
        writebool('Tips','ShowAtStart',lmdtipdlg1.ShowAtStart);
      end;
  finally
    inifile.free;
  end;
end;

end.
